{% extends "base.html" %}
{% load static %}

{% block title %} Project details {% endblock %}
{% block titleHeader %}
{% if message %}
My projects
{% else %}
{{ project.title }}
{% endif %}
{% endblock %}

{% block titleSubHeader %} {% endblock %}

{% block libraries %}
<script src="{% static 'js/jquery.autocomplete.js' %}"></script>
<script src="{% static 'js/editorjs.js' %}"></script>
<script src="https://cdn.jsdelivr.net/npm/codex.editor.header@2.0.4/dist/bundle.js"></script>
<script src="https://cdn.jsdelivr.net/npm/@editorjs/header@latest"></script><!-- Header -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/simple-image@latest"></script><!-- Image -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/delimiter@latest"></script><!-- Delimiter -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/list@latest"></script><!-- List -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/checklist@latest"></script><!-- Checklist -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/quote@latest"></script><!-- Quote -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/code@latest"></script><!-- Code -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/embed@latest"></script><!-- Embed -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/table@latest"></script><!-- Table -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/link@latest"></script><!-- Link -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/warning@latest"></script><!-- Warning -->

<script src="https://cdn.jsdelivr.net/npm/@editorjs/marker@latest"></script><!-- Marker -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/inline-code@latest"></script><!-- Inline Code -->


<script src="https://cdn.jsdelivr.net/npm/handsontable@8.3.2/dist/handsontable.full.min.js"></script>
<link href="https://cdn.jsdelivr.net/npm/handsontable@8.3.2/dist/handsontable.full.min.css" rel="stylesheet" media="screen">
{% endblock %}

{% block content %}


<div class="container-fluid">

    <div class="row">
        <div class="col-12 col-xl-6">
            {% if message_action %}
            <div class="alert alert-success alert-dismissible fade show" role="alert">
                {{message_action}}
                <button type="button" class="btn-close" data-bs-dismiss="alert"
                        aria-label="Close"></button>
            </div>
            {% endif %}

            {% if message %}
            <p>
                <a href="{% url 'project_list' %}" class="btn btn-primary">
                    <i class="fas fa-chevron-circle-left"></i> Project List
                </a>
            </p>
            <div class="alert alert-danger" role="alert">
                <p>{{ message }}</p>
                <p>Login In :<a class="alert-link" href="{% url 'login'%}">here</a>.
                </p>
            </div>
            {% else %}

            <h2> Generality
                {% if user_permission == "All" or user_permission == "Edit" %}
                <a class="btn btn-primary btn-sm"
                               href="{% url 'project_edit' id_project=project.id %}"><i
                    class="fas fa-pen"></i> Edit</a>
                {% endif %}
            </h2>
            <hr>
            <p>
                <a href="{% url 'project_list' %}" class="btn btn-primary">
                    <i class="fas fa-chevron-circle-left"></i> Project List
                </a>
            </p>
            <h3>Status</h3>
            <span class="badge bg-secondary {% if project.access == 'Private' %} bg-danger {% else %} bg-success {% endif %} ">{{ project.access }}</span>
            <h3 class="mt-2">Tags
            {% if user_permission == "All" or user_permission == "Edit" %}
                <button type="button" class="btn btn-success btn-sm"
                        data-bs-toggle="modal"
                        data-bs-target="#addTag">
                    <i class="fas fa-plus"></i> Add
                </button>

                <button type="button" class="btn btn-danger btn-sm"
                        data-bs-toggle="modal"
                        data-bs-target="#removeTag">
                    <i class="fas fa-minus"></i> Remove
                </button>
                {% endif %}
            </h3>
            {% for tag in tags %}
                <span class="badge" style="background-color: {{tag.tag.color}}!important;">{{tag.tag.label}}</span>
            {% endfor %}

            <h3 class="mt-2">Alias</h3>
            <p>{{ project.alias }}</p>
            <h3>Description</h3>
            <p>{{ project.description | linebreaksbr }}</p>

            <h3 class="mt-2">History</h3>
            <p><i class="fas fa-calendar-day"></i> Created at :
                {{ project.created_date|date:"l d F Y (H:i)" }}</p>
            <p><i class="fas fa-calendar-day"></i> Last modification :
                {{ project.last_modification_date|date:"l d F Y (H:i)" }}</p>

            <h2>Collaborators
                {% if user_permission == "All" %}
                <button type="button" class="btn btn-success btn-sm"
                        data-bs-toggle="modal"
                        data-bs-target="#addCollab">
                    <i class="fas fa-plus"></i> Add
                </button>
                {% endif %}
            </h2>
            <hr>
            <div class="table-responsive-xxl">
            <table class="table table-striped">
                <thead class="table-secondary">
                <tr>
                    <th scope="col">#</th>
                    <th scope="col">Username</th>
                    <th scope="col">Name</th>
                    <th scope="col">Email</th>
                    {% if user_permission == "All" %}
                    <th scope="col">Permission</th>
                    <th scope="col">Action</th>
                    {% endif %}
                </tr>
                </thead>
                <tbody>

                {% for collaborator in collaborators %}
                <tr>
                    <th scope="row">{{forloop.counter}}</th>
                    <td>{{collaborator.applicationUser.user.username}}</td>
                    <td>{{collaborator.applicationUser.user.first_name | lower |capfirst }}
                        {{collaborator.applicationUser.user.last_name | upper}}
                    </td>
                    <td><a href="mailto:{{collaborator.user.email}}">
                        {{ collaborator.applicationUser.user.email}}</a>
                    </td>
                    {% if user_permission == "All" %}
                    <td>
                        <form class="row g-2"
                              id="update_permission_{{forloop.counter}}" method="POST">
                            {% csrf_token %}
                            <div class="col-8">
                                <select name="permission"
                                        id="update_permission_select_{{forloop.counter}}"
                                        class="form-select">
                                    {% for p in permission %}
                                    <option value="{{ p.0 }}" {% if p.0 == collaborator.permission %}selected {% endif %}>{{ p.1 }}
                                    </option>
                                    {% endfor %}
                                </select>
                            </div>
                            <div class="col-4">
                                <input name="username_input" type="hidden" value="{{collaborator.applicationUser.user.username}}">
                                <button name = "permission_btn"
                                        type="submit" class="btn btn-primary">
                                    <i class="fas fa-pen"></i> Modify
                                </button>
                            </div>
                        </form>
                    </td>
                    <td>
                        <a class="btn btn-danger"
                           href="{% url 'project_delete_collaborator' id_project=project.id username=collaborator.applicationUser.user.username %}">Delete</a>
                    </td>
                    {% endif %}
                </tr>
                {% endfor %}
                </tbody>
            </table>
            </div>
            <h2>Metadata
            {% if user_permission == "All" %}
            <a href="{% url 'metadata_create' id_project=project.id %}" class="btn btn-success btn-sm"> Create
            metadata table</a>

            {% endif %}
            </h2>
            <hr>
            <table class="table table-striped">
                <thead class="table-secondary">
                <tr>
                    <th scope="col">#</th>
                    <th scope="col">Database</th>
                    <th scope="col">Description</th>
                    <th scope="col">Mandatory (%)</th>
                    <th scope="col">Recommended (%)</th>
                    <th scope="col">Optional (%)</th>
                    {% if user_permission == "All" %}
                    <th scope="col">Action</th>
                    {% endif %}
                </tr>
                </thead>
                <tbody>

                {% for m in meta %}
                <tr>
                    <th scope="row">{{forloop.counter}}</th>
                    <td>{{ m.checklist.database.name }}</td>
                    <td>{{ m.short_description }}</td>
                    <td>{{ m.mandatory }}</td>
                    <td>{{ m.recommended }}</td>
                    <td>{{ m.optional }}</td>
                    {% if user_permission == "All" %}
                    <td>
                        <a href="{% url 'metadata_detail' id_metadata=m.id %}"
                           class="btn btn-primary btn-sm">Details</a>
                        <button type="button" class="btn btn-danger btn-sm"
                                data-bs-toggle="modal" data-bs-target="#deleteModal_{{forloop.counter}}">
                            Delete
                        </button>
                    </td>
                    {% endif %}
                </tr>
                {% endfor %}
                </tbody>
            </table>

        </div>

        <div class="col-12 col-xl-6">
            <h2>Notes
            <button type="button" class="btn btn-sm btn-default no_focus" aria-disabled="true"
                    data-bs-toggle='popover'
                    title="EditoJS"
                    data-bs-content="A little lost with the publisher? All the documentation is available : <a href='https://editorjs.io/' target='_blank'>here</a>">

               <i class="fas fa-question-circle"></i>

            </button>
            </h2>
            <hr>
            <div id="editorjs"></div>

            <button name = "saveButton" id="saveButton"
                    class="btn btn-success mt-2">
               <i class="fas fa-save"></i> Save
            </button>
            <div id="snackbar">Save successfully</div>

        </div>
    </div>

    <!-------------------------------------------------------------------------
                                        Modal
    -------------------------------------------------------------------------->

    <div class="modal fade" id="addCollab" tabindex="-1"
         aria-labelledby="addCollab" aria-hidden="true">
        <div class="modal-dialog">

            <div class="modal-content">
                <form id="search_user" method="POST">
                    <div class="modal-header">
                        <h5 class="modal-title" id="exampleModalLabel">Add
                            collaborator </h5>
                        <button type="button" class="btn-close"
                                data-bs-dismiss="modal"
                                aria-label="Close"></button>
                    </div>
                    <div class="modal-body">

                        {% csrf_token %}
                        <p><b>Username</b></p>
                        <input type="text" class="form-control" id="txtSearch"
                               name="txtSearch">

                        <p><b>Permission</b></p>
                        <select name="permission" id="permission-select"
                                class="form-select">
                            {% for p in permission %}
                            <option value="{{ p.0 }}">{{ p.1 }}</option>
                            {% endfor %}
                        </select>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary"
                                data-bs-dismiss="modal">Close
                        </button>
                        <button type="submit" class="btn btn-primary"
                                id="success" name="create_work_on" disabled>
                            <i class="fas fa-plus"></i> Add
                        </button>
                    </div>
                </form>
            </div>
        </div>
    </div>

    {% for m in meta %}
    <div class="modal fade" id="deleteModal_{{forloop.counter}}" tabindex="-1"
         aria-labelledby="ModalLabel" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="deleteModalLabel">Delete this metadata ? </h5>
                    <button type="button" class="btn-close"
                            data-bs-dismiss="modal"
                            aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    You have started the metadata deletion procedure. Are you sure you want to delete the metadata?
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary"
                            data-bs-dismiss="modal">Close
                    </button>
                    <a type="button" class="btn btn-danger" href="{% url 'metadata_delete' id_metadata=m.id %}">Delete
                    </a>
                </div>
            </div>
        </div>
    </div>
    {% endfor %}

    <div class="modal fade" id="addTag" tabindex="-1"
         aria-labelledby="addTag" aria-hidden="true">
        <div class="modal-dialog">

            <div class="modal-content">
                <form id="add_tag_form" method="POST">
                    <div class="modal-header">
                        <h5 class="modal-title">Add tag </h5>
                        <button type="button" class="btn-close"
                                data-bs-dismiss="modal"
                                aria-label="Close"></button>
                    </div>
                    <div class="modal-body">

                        {% csrf_token %}
                        <p><b>Label</b></p>
                        <input type="text" class="form-control" id="tag_label"
                               name="tag_label" onkeyup="stoppedTyping()">

                        <p><b>Color</b></p>
                        <input type="color" id="tag_color" name="tag_color"
                               value="#e66465">
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary"
                                data-bs-dismiss="modal">Close
                        </button>
                        <button type="submit" class="btn btn-primary"
                                id="submit_tag" name="create_tag_project"
                                disabled>
                            <i class="fas fa-plus"></i> Add
                        </button>
                    </div>
                </form>
            </div>
        </div>
    </div>

    <div class="modal fade" id="removeTag" tabindex="-1"
         aria-labelledby="removeTag" aria-hidden="true">
        <div class="modal-dialog">

            <div class="modal-content">
                <form id="removeTag_form" method="POST">
                    <div class="modal-header">
                        <h5 class="modal-title">Remove tag </h5>
                        <button type="button" class="btn-close"
                                data-bs-dismiss="modal"
                                aria-label="Close"></button>
                    </div>
                    <div class="modal-body">

                        {% csrf_token %}
                        <p><b>Label</b></p>
                        <select class="form-select" aria-label="multiple select example" name="select_remove_tag">
                            {% for tag in tags %}
                                <option {% if forloop.first %} selected {% endif %} value="{{tag.tag.label}}">{{tag.tag.label}}</option>
                            {% endfor %}
                        </select>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary"
                                data-bs-dismiss="modal">Close
                        </button>
                        <button type="submit" class="btn btn-danger"
                                id="submit_remove_tag" name="remove_tag_project">
                            <i class="fas fa-minus"></i> Remove
                        </button>
                    </div>
                </form>
            </div>
        </div>
    </div>

    <script>

        /* ####################################################################

        TAG

        #################################################################### */

        function stoppedTyping(){
            var l = document.getElementById('tag_label').value.length ;
            if(l > 0) {
                $("#submit_tag").prop("disabled", false);
            } else {
                $("#submit_tag").prop("disabled", true);
            }
        }

        // AD COLLABORATOR
        $(document).ready(function(){

            $("#txtSearch").keyup(function(){
                if($(this).val()=== '') {
                  $("#success").attr("disabled", 'disabled');
                }
            });
            $('#txtSearch').autocomplete({
                serviceUrl: "{% url 'autocomplete_username' %}",
                dataType: "json",
                minChars: 2,
                onInvalidateSelection: function () {
                  $("#success").prop("disabled", true);
                },
                onSelect: function (suggestion) {
                    $("#success").removeAttr("disabled");
                }

            });
        });

        // EDITOR JS
        var False = false;
        var True = true;

        var editor = new EditorJS({
          /**
           * Enable/Disable the read only mode
           */
          {% if user_permission == "Read" %}
          readOnly: true,
          {% else %}
          readOnly: false,
          {% endif %}

          /**
           * Wrapper of Editor
           */
          holder: 'editorjs',

          /**
           * Common Inline Toolbar settings
           * - if true (or not specified), the order from 'tool' property will be used
           * - if an array of tool names, this order will be used
           */
          // inlineToolbar: ['link', 'marker', 'bold', 'italic'],
          // inlineToolbar: true,

          /**
           * Tools list
           */
          tools: {
            /**
             * Each Tool is a Plugin. Pass them via 'class' option with necessary settings {@link docs/tools.md}
             */
            header: {
              class: Header,
              inlineToolbar: ['marker', 'link'],
              config: {
                placeholder: 'Header'
              },
              shortcut: 'CMD+SHIFT+H'
            },

            /**
             * Or pass class directly without any configuration
             */
            image: SimpleImage,

            list: {
              class: List,
              inlineToolbar: true,
              shortcut: 'CMD+SHIFT+L'
            },

            checklist: {
              class: Checklist,
              inlineToolbar: true,
            },

            quote: {
              class: Quote,
              inlineToolbar: true,
              config: {
                quotePlaceholder: 'Enter a quote',
                captionPlaceholder: 'Quote\'s author',
              },
              shortcut: 'CMD+SHIFT+O'
            },

            warning: Warning,

            marker: {
              class:  Marker,
              shortcut: 'CMD+SHIFT+M'
            },

            code: {
              class:  CodeTool,
              shortcut: 'CMD+SHIFT+C'
            },

            delimiter: Delimiter,

            inlineCode: {
              class: InlineCode,
              shortcut: 'CMD+SHIFT+C'
            },

            linkTool: LinkTool,

            embed: {
              class: Embed,
              inlineToolbar: true,
            },

            table: {
              class: Table,
              inlineToolbar: true,
              shortcut: 'CMD+ALT+T'
            },

          },

          /**
           * This Tool will be used as default
           */
          // defaultBlock: 'paragraph',

          /**
           * Initial Editor data
           */
           {% if project.notepad %}
                data: {{ project.notepad | safe }},
           {% else %}
                data: {},
           {% endif %}

          onReady: function(){
            // saveButton.click();
          },
          onChange: function() {
            document.getElementById("saveButton").classList.add('btn-warning');
            document.getElementById("saveButton").classList.remove('btn-success');
          }
        });
        const saveButton = document.getElementById('saveButton');

        /**
         * Saving example
         */
        saveButton.addEventListener('click', function () {
          editor.save()
            .then((savedData) => {
                $.ajax({
                    type: "POST",
                    contentType: "application/json",
                    url : "{% url 'save_notepad' id_project=project.id %}",
                     headers:{
                        "X-CSRFToken": '{{ csrf_token }}'
                     },
                    data : JSON.stringify(savedData),
                    dataType: "json"
                });

                  // Get the snackbar DIV
                  var x = document.getElementById("snackbar");

                  // Add the "show" class to DIV
                  x.className = "show";

                  // After 3 seconds, remove the show class from DIV
                  setTimeout(function(){ x.className = x.className.replace("show", ""); }, 3000);

                  document.getElementById("saveButton").classList.add('btn-success');
                  document.getElementById("saveButton").classList.remove('btn-warning');

            })
            .catch((error) => {
              document.getElementById("check").innerHTML="Error";
                 setTimeout(function(){
                 document.getElementById("check").innerHTML="";
                 },3000);
            });
        });
    </script>
    {% endif %}

</div>
{% endblock %}